/**
Copyright © 2014 Marko Niinimaki. All Rights Reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

3. The name of the author may not be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**/
package org.natto.swingGUI;

import java.awt.Frame;
import javax.swing.DefaultListModel;

/**
 * Shows a list of items given in the constructor.
 * @author man@cern.ch
 */
public class DirPresenter extends javax.swing.JDialog {

    private int selectedIndex = -1; //set in select
    DefaultListModel myModel = new DefaultListModel();

    public int getselectedIndex() {
        return selectedIndex;
    }

    /**
     * Creates new form DirPresenter.
     * @param fileNames names in the directory
     * @param isDirArr for each entry, true if this is a directory
     */
    public DirPresenter(String[] fileNames, boolean[] isDirArr) {
        super(new Frame(), true);
        for (int i = 0; i < fileNames.length; i++) {
            String hName = fileNames[i];
            if (isDirArr[i]) { hName = hName + " <dir>"; }
            myModel.addElement(hName);
        }
        initComponents();
        //fileList.setModel(myModel);
        setVisible(true);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonPanel = new javax.swing.JPanel();
        selectButton = new javax.swing.JButton();
        instRuctions = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        fileList = new javax.swing.JList();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Output");
        setMinimumSize(new java.awt.Dimension(100, 200));

        buttonPanel.setMaximumSize(new java.awt.Dimension(32767, 50));
        buttonPanel.setMinimumSize(new java.awt.Dimension(100, 50));
        buttonPanel.setLayout(new java.awt.BorderLayout());

        selectButton.setText("Select");
        selectButton.setEnabled(false);
        selectButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectButtonAction(evt);
            }
        });
        buttonPanel.add(selectButton, java.awt.BorderLayout.CENTER);

        getContentPane().add(buttonPanel, java.awt.BorderLayout.PAGE_END);

        instRuctions.setText("Select from the list or click here to close.");
        instRuctions.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                instRuctionsMouseClicked(evt);
            }
        });
        getContentPane().add(instRuctions, java.awt.BorderLayout.PAGE_START);

        fileList.setModel(myModel);
        fileList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        fileList.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        fileList.setInheritsPopupMenu(true);
        fileList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                fileListValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(fileList);

        getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void selectButtonAction(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectButtonAction
        //set selected index
        selectedIndex = fileList.getSelectedIndex();
        setVisible(false);
    }//GEN-LAST:event_selectButtonAction

    private void instRuctionsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_instRuctionsMouseClicked
        setVisible(false);
    }//GEN-LAST:event_instRuctionsMouseClicked

    private void fileListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_fileListValueChanged
       selectButton.setEnabled(true);
    }//GEN-LAST:event_fileListValueChanged


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JList fileList;
    private javax.swing.JLabel instRuctions;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton selectButton;
    // End of variables declaration//GEN-END:variables
}
